#include <TGClient.h>
#include <TCanvas.h>
#include <TF1.h>
#include <TRandom.h>
#include <TGButton.h>
#include <TRootEmbeddedCanvas.h>
#include <TTimer.h>
#include "ex13.h"

ClassImp(MyMainFrame)
MyMainFrame::MyMainFrame()
: TGMainFrame() {
}

MyMainFrame::MyMainFrame(const TGWindow *p,UInt_t w,UInt_t h)
: TGMainFrame(p,w,h) {
// Creates widgets of the example
fEcanvas = new TRootEmbeddedCanvas ("Ecanvas",this,200,200);
AddFrame(fEcanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY,
10,10,10,1));
TGHorizontalFrame *hframe=new TGHorizontalFrame(this, 200,40);
draw = new TGTextButton(hframe,"&Draw");
draw->Connect("Clicked()","MyMainFrame",this,"DoDraw()");
hframe->AddFrame(draw, new TGLayoutHints(kLHintsCenterX,5,5,3,4));
start = new TGTextButton(hframe,"&Start");
start->Connect("Clicked()","MyMainFrame",this,"Startthread()");
hframe->AddFrame(start, new TGLayoutHints(kLHintsCenterX,5,5,3,4));
stop = new TGTextButton(hframe,"&Stop");
stop->Connect("Clicked()","MyMainFrame",this,"Stopthread()");
hframe->AddFrame(stop, new TGLayoutHints(kLHintsCenterX,5,5,3,4));
number01 = new TGNumberEntry(hframe, (Double_t) 0,4,-1,(TGNumberFormat::EStyle) 5);
hframe->AddFrame(number01, new TGLayoutHints(kLHintsLeft,5,5,3,4));

TGTextButton *exit = new TGTextButton(hframe,"&Exit ",
"gApplication->Terminate()");

mTh = 0;
mTh= new TThread("memberfunction",(void(*)(void *))&MyMainFrame::Thread0,(void*) this);
// mTh->Connect("DoDraw()","MyMainFrame",this,"DoDraw()");
TQObject::Connect("DoDraw()","MyMainFrame",this,"DoDraw()");

// Create a TTimer (timer called every 1000 msec)
timer = new TTimer();
timer->Connect("Timeout()", "MyMainFrame",
this, "DoDraw()");

start->SetState(kButtonUp , kTRUE);
stop->SetState(kButtonDisabled, kFALSE);
hframe->AddFrame(exit, new TGLayoutHints(kLHintsCenterX,5,5,3,4));
AddFrame(hframe,new TGLayoutHints(kLHintsCenterX,2,2,2,2));
// Sets window name and shows the main frame
SetWindowName("Simple Example");
MapSubwindows();
Resize(GetDefaultSize());
MapWindow();
}
void MyMainFrame::DoDraw() {
// Draws function graphics in randomly choosen interval
TF1 *f1 = new TF1("f1","sin(x)/x",0,gRandom->Rndm()*10);
f1->SetFillColor(19);
f1->SetFillStyle(1);
f1->SetLineWidth(3);
f1->Draw();
TCanvas *fCanvas = fEcanvas->GetCanvas();
fCanvas->cd();
fCanvas->Update();
//  i++;
number01->SetIntNumber(i);
}

Int_t MyMainFrame::Startthread() 
{
// start the loop thread
i = 100;
timer->Start(1000, kFALSE);   // 1 second REPEATED
// timer->TurnOn();
start->SetState( kButtonDisabled , kFALSE);
stop->SetState(kButtonUp , kTRUE);
stopbpressed = kFALSE;
// start the thread here
printf("Starting Thread 1, i = %d \n",i);
  if(!mTh){
  mTh= new TThread("memberfunction",(void(*)(void *))&MyMainFrame::Thread0,(void*) this);
	  }
  mTh->Run();
  return 0;
}

void MyMainFrame::Stopthread() 
{
printf("Executing stop thread\n");
timer->Stop();
start->SetState(kButtonUp , kFALSE);
stop->SetState(kButtonDisabled, kFALSE);
TThread::Lock();
number01->SetIntNumber(i);
stopbpressed = kTRUE ;
TThread::UnLock();
}

MyMainFrame::~MyMainFrame() {
// Clean up used widgets: frames, buttons, layouthints
Cleanup();
}

//*********************************
void* MyMainFrame::Thread0(void* arg)
{
while ( (stopbpressed == kFALSE) & ( i < 110))
	{
	printf("In thread Thread0 loop , i = %d \n",i);
	TThread::Lock();
        i++;
	TThread::UnLock();
	
	if ( i == 105) {
	i = 108;
	Emit("DoDraw()");
			}
	gSystem->Sleep(1000);
	}
TThread::Lock();
stopbpressed = kFALSE ; 
TThread::UnLock();
// stop thread and exit
printf("exiting thread\n");
return 0;
}

